## Bereken de kans op een 'flush' in een pokerhand met
# behulp van de Monte Carlomethode

import random

def is_flush (kaarten):
    index = 1
    kleur = kaarten[0] // 13
    while index < 5 and kaarten[index]//13 == kleur:
        index += 1
    return index == 5

def neem_5_kaarten ():
    pak = list(range(52))
    resultaat = []
    for _ in range(5):
        keuze = random.randint(0, len(pak)-1)
        resultaat.append(pak.pop(keuze)) 
    return resultaat               

aantal_pogingen = 1_000_000    # 1 miljoen pogingen
aantal_flush = 0
for _ in range(aantal_pogingen):
    if is_flush (neem_5_kaarten ()):
        aantal_flush += 1
        
print (f"Kans = {aantal_flush / aantal_pogingen * 100}%")
