## Bereken de kans op een 'full house' in een pokerhand met
# behulp van de Monte Carlo-methode

from random import randint

def is_full_house (kaarten):
    aantallen = [0] * 13
    for kaart in kaarten:
        aantallen[kaart % 13] += 1
    return 2 in aantallen and 3 in aantallen

def neem_5_kaarten ():
    resultaat = []
    while len(resultaat) < 5:
        keuze = randint(0,51)
        if keuze not in resultaat:
            resultaat.append(keuze)
    return resultaat

aantal_pogingen = 1_000_000    # 1 miljoen pogingen
aantal_full_house = 0
for _ in range(aantal_pogingen):
    if is_full_house (neem_5_kaarten ()):
        aantal_full_house += 1
        
print (f"Kans = {aantal_full_house / aantal_pogingen * 100}%")
