## Tekent een dobbelstenen met 0 t.e.m. 9 ogen en slaat die op in bestanden
#
# Versie 1 (van 3): 
# - slaat de beschrijving van een dobbelsteen op als 9 aan/uit-symbolen
# - berekent de index uit rij en kolom

from PIL import Image, ImageDraw

patronen = [ ".........", 
             "....0....", "0.......0", "0...0...0",
             "0.0...0.0", "0.0.0.0.0", "000...000",
             "000.0.000", "0000.0000", "000000000" ]

def teken_dobbelsteen (aantal_ogen):
    prent = Image.new("RGB", [200, 200], color="white")
    doek = ImageDraw.Draw(prent)
    doek.rounded_rectangle([20, 20, 180, 180], radius=20, fill="black")

    patroon = patronen[aantal_ogen]
    for rij in range (3):
        for kolom in range (3):
            index = 3*rij + kolom
            if patroon[index] == '0':
                x = 55+45*kolom
                y = 55+45*rij
                doek.ellipse([x-20,y-20,x+20,y+20], fill="white")
               
    prent.save(f"dobbelsteen-{aantal_ogen}.png")

## Maakt prenten voor 0 tem 9 ogen:
for n in range (10):
    teken_dobbelsteen(n)
