## Tekent een dobbelstenen met 0 t.e.m. 9 ogen en slaat die op in bestanden
#
# Versie 2 (van 3): 
# - sla de beschrijving van een dobbelsteen op als posities 0..8 van de ogen
# - hou zelf de index bij door die bij elke stap met 1 op te verhogen

from PIL import Image, ImageDraw

patronen = [ "", "4", "08", "048", "0268", 
             "02468", "012678", "0124678", "01235678", "012345678" 
           ]

def teken_dobbelsteen (aantal_ogen):
    prent = Image.new("RGB", [200, 200], color="white")
    doek = ImageDraw.Draw(prent)
    doek.rounded_rectangle([20, 20, 180, 180], radius=20, fill="black")

    ogen = patronen[aantal_ogen]
    index = 0
    for rij in range (3):
        for kolom in range (3):
            if str(index) in ogen:
                x = 55+45*kolom
                y = 55+45*rij
                doek.ellipse([x-20,y-20,x+20,y+20], fill="white")
            index += 1
               
    prent.save(f"dobbelsteen-{aantal_ogen}.png")

## Maakt prenten voor 0 tem 9 ogen:
for n in range (10):
    teken_dobbelsteen(n)
