## Tekent een dobbelstenen met 0 t.e.m. 9 ogen en slaat die op in bestanden
#
# Versie 3 (van 3): 
# - slaat de beschrijving van een dobbelsteen op als 9 aan/uit-symbolen (zoals in versie 2)
# - berekent rij en kolom uit de index, haalt index uit patroon

from PIL import Image, ImageDraw

patronen = [ "", "4", "08", "048", "0268", 
             "02468", "012678", "0124678", "01235678", "012345678" 
           ]

def teken_dobbelsteen (aantal_ogen):
    prent = Image.new("RGB", [200, 200], color="white")
    doek = ImageDraw.Draw(prent)
    doek.rounded_rectangle([20, 20, 180, 180], radius=20, fill="black")

    for index_teken in patronen[aantal_ogen]:
        index = int(index_teken)
        rij = index // 3
        kolom = index % 3
        x = 55+45*kolom
        y = 55+45*rij
        doek.ellipse([x-20,y-20,x+20,y+20], fill="white")
               
    prent.save(f"dobbelsteen-{aantal_ogen}.png")


## Maakt prenten voor 0 tem 9 ogen:
for n in range (10):
    teken_dobbelsteen(n)
