# Zelfde als versie 2, maar met enkele bijkomende verfraaiingen aan de grafiek

frequentie = [0] * 10 # in de tekst heet dit 'aantal'

with open ("stat-1-1_n.csv", "r") as bestand:
    # lees eerste drie lijnen in, maar gooi die weg
    bestand.readline() 
    bestand.readline() 
    bestand.readline() 
    # verwerk nu de rest van het bestand
    for lijn in bestand:
        laatste_puntkomma = lijn.rfind(";")
        eerste_cijfer = int(lijn[laatste_puntkomma+1])
        frequentie[eerste_cijfer] += 1
    # laatste lijn van de tabel mocht niet worden meegeteld
    frequentie[eerste_cijfer] -= 1

from matplotlib import pyplot    

# omzetten naar percentages en opslaan in een lijst, ten behoeve van matplotlib
y_waarden = []
som = sum(frequentie)
for cijfer in range (1,10):
    percentage = frequentie[cijfer] / som * 100
    y_waarden.append(percentage)

x_waarden = list(range(1,10)) # werkt ook zonder list(…)


# enkele eenvoudige 'verfraaiingen"
pyplot.bar(x_waarden,y_waarden,label="Inwonersaantallen",color="green") # label + kleur toegevoegd
pyplot.title("De wet van Benford")
pyplot.xlabel("Eerste cijfer")
pyplot.ylabel("Frequentie")
pyplot.legend()

# bijkomende aanpassingen aan de labels van de assen
from matplotlib import ticker    
#
assen = pyplot.gca()
assen.yaxis.set_major_formatter(ticker.PercentFormatter(decimals=0))
assen.xaxis.set_major_locator(ticker.MultipleLocator(1))

pyplot.show()
