# Controleer de wet van Benford voor de huisnummers van de Vlaamse scholen
# informatie uit https://data-onderwijs.vlaanderen.be/onderwijsaanbod/lijst?n=2&hz=true&hs=311

from matplotlib import pyplot    

frequentie = [0] * 10

with open ("Scholen-gewoon-secundair-onderwijs.csv", "r") as bestand:
    # lees eerste lijn in maar gooi die weg
    bestand.readline() 
    # lees nu de rest van het bestand
    for lijn in bestand:
        huisnummer = lijn.split(";")[7]
        eerste_teken = huisnummer[1]  # er staan dubbele quotes!
        if eerste_teken.isdigit():    # er is een school met een eigenaardig huisnummer
            eerste_cijfer = int(eerste_teken)
            frequentie[eerste_cijfer] += 1

# omzetten naar percentages en opslaan in een lijst, ten behoeve van matplotlib
y_waarden = []
som = sum(frequentie)
for cijfer in range (1,10):
    percentage = frequentie[cijfer] / som * 100
    y_waarden.append(percentage)

x_waarden = list(range(1,10)) # werkt ook zonder list(…)

pyplot.bar(x_waarden,y_waarden) 
pyplot.show()
