# Maak een grafiek van de bevolkingsaangroei in België
#
# Eerste lijn van het bestand mag worden overgeslagen
# Bij de volgende lijnen zijn we niet geïnteresseerd in de eerste kolom

from matplotlib import pyplot

with open("bevolking.csv") as bestand:
    # we gebruiken de eerste lijn om te weten hoeveel kolommen we verwachten
    eerste_lijn = bestand.readline()
    aantal_jaren = eerste_lijn.count(",")
    totalen = [0] * aantal_jaren

    # we overlopen de rest van het bestand lijn per lijn
    for lijn in bestand:
        delen = lijn.split(",")
        for i in range(aantal_jaren):
            totalen[i] += int(delen[i+1])
    
x_waarden = list(range(2014,2014+aantal_jaren))
y_waarden = totalen

pyplot.plot (x_waarden, y_waarden)
pyplot.show()




