## Variant die knippen en plakken vermijdt bij de procedure tijdsduur
#  door de herschik-procedure als parameter mee te geven

from time import time
from random import randint
from matplotlib import pyplot

# herschik-methode van oefening 12.2
def herschik_12_2 (lijst):
    # index waar het volgende oneven getal wordt ingevoegd
    index_oneven = len(lijst)-1
    while index_oneven >= 0 and lijst[index_oneven] % 2 != 0:
        index_oneven -= 1

    index = 0
    while index < index_oneven:        
        getal = lijst[index]
        if getal % 2 == 0:
            index += 1
        else:
            # schuif alles uit [index+1,index_oneven] één plaats naar voor
            for i in range(index,index_oneven):
                lijst[i] = lijst[i+1]
            # plaats getal in oneven gebied
            lijst[index_oneven] = getal
            index_oneven -= 1

# herschik-methode van oefening 12.3
def herschik_12_3 (lijst):
    # zoek index van eerste oneven getal
    index_links = 0
    while index_links < len(lijst) and lijst[index_links] % 2 == 0:
        index_links += 1
    # zoek index van laatste even getal
    index_rechts = len(lijst)-1
    while index_rechts >= 0 and lijst[index_rechts] % 2 != 0:
        index_rechts -= 1
    
    # herhaal zolang links rechts niet is gepasseerd
    while index_links < index_rechts:
        # verwissel de getallen
        t = lijst[index_links]
        lijst[index_links] = lijst[index_rechts]
        lijst[index_rechts] = t
        # zoek volgende oneven getal
        index_links += 1
        while lijst[index_links] % 2 == 0:
            index_links += 1
        # zoek volgende even getal
        index_rechts -= 1
        while lijst[index_rechts] % 2 != 0:
            index_rechts -= 1

# geef een lijst terug van een gegeven lengte, gevuld met willekeurig getallen
def maak_lijst(lengte):
    resultaat = []
    for _ in range(lengte):
        resultaat.append(randint(0,100))
    return resultaat

# hoelang duurt het om 20 willekeurige lijsten van de gegeven lengte te herschikken
def tijdsduur (lengte, herschik):
    # stop 20 lijsten in een lijst van lijsten
    lijsten = []
    for _ in range(20):
        lijsten.append (maak_lijst(lengte))
    tijd_begin = time ()
    for lijst in lijsten:
        herschik(lijst)
    tijd_einde = time ()
    return tijd_einde - tijd_begin

## De metingen
tijden_12_2 = []
tijden_12_3 = []
lengtes = list (range(50,2050,50))

for lengte in lengtes:
    # eerste methode
    tijden_12_2.append(tijdsduur(lengte, herschik_12_2))
    tijden_12_3.append(tijdsduur(lengte, herschik_12_3))

## Tekenen
pyplot.plot (lengtes, tijden_12_2, color="black", label="12.2")
pyplot.plot (lengtes, tijden_12_3, color="red", label="12.3")
pyplot.legend()
pyplot.show()

# druk de tijden af voor lengte 1000 en 2000
print (tijden_12_2[19],tijden_12_2[39])
print (tijden_12_3[19],tijden_12_3[39])