## Maakt het bestand 'gondor-graaf.txt' uit 'gondor-graaf-abc.txt' en 'gondor-namen-abc.txt'
# versie 1 - in 3 stappen

# Lees de vertaaltabel in als dictionary sleutel: letter, waarde: naam v/d stad
vertaaltabel = {} 
with open ('gondor-namen-abc.txt') as bestand:
    for line in bestand:
        sleutel = line[0]
        waarde = line[2:-1] # laatste teken (new line) moet je weglaten
        vertaaltabel[sleutel] = waarde

# Lees de graaf in als dictionary.
# Opmerking: Versie 2 van deze oplossing toont dat je het ook zonder deze dictionary kunt doen
graaf = {}        
with open ('gondor-graaf-abc.txt') as bestand:
    for line in bestand:
        sleutel = line[0]
        waarde = line[1:-1]
        graaf[sleutel] = waarde

# controle of elke verbinding wel twee keer voorkomt (niet in opgave)
for sleutel,waarde in graaf.items():
    for letter in waarde:
        if sleutel not in graaf[letter]:
            print (f"{sleutel} niet in graaf[{letter}]")

# Doe de vertaling
with open ('gondor-graaf.txt', 'w') as bestand:
    for sleutel,waarde in graaf.items():
        print (vertaaltabel[sleutel],end='',file=bestand)
        for letter in waarde:
            print('|'+vertaaltabel[letter],end='',file=bestand)
        print (file=bestand)   # ga naar nieuwe lijn...
