## Maakt het bestand 'gondor-graaf.txt' uit 'gondor-graaf-abc.txt' en 'gondor-namen-abc.txt'
# versie 2 - laatste stapt leest en schrijft tegelijkertijd

# Lees de vertaaltabel in als dictionary sleutel: letter, waarde: naam v/d stad
vertaaltabel = {} 
with open ('gondor-namen-abc.txt') as bestand:
    for line in bestand:
        sleutel = line[0]
        waarde = line[2:-1] # laatste teken (new line) moet je weglaten
        vertaaltabel[sleutel] = waarde

# Lees de graaf in als dictionary
graaf = {}        
with open ('gondor-graaf-abc.txt') as bestand:
    for line in bestand:
        sleutel = line[0]
        waarde = line[1:-1]
        graaf[sleutel] = waarde

# controle of elke verbinding wel twee keer voorkomt (niet in opgave)
for sleutel,waarde in graaf.items():
    for letter in waarde:
        if sleutel not in graaf[letter]:
            print (f"{sleutel} niet in graaf[{letter}]")

# Vertaal het invoerbestand rechtstreeks naar het uitvoerbestand
with open ('gondor-graaf-abc.txt') as invoer:
    with open ('gondor-graaf.txt', 'w') as uitvoer:
        for line in invoer:
            # eerste element wordt niet voorafgegaan door een verticale streep en moet appart    
            print (vertaaltabel[line[0]],end='', file=uitvoer)
            for letter in line[1:-1]: # opgelet laatste letterteken (new line) niet meeverwerken!
                print('|'+vertaaltabel[letter],end='',file=uitvoer)
            print (file=uitvoer)   # ga naar nieuwe lijn...
