# Vergelijkt de snelheid van insertion sort met die van merge sort

# code overgenomen uit 5_merge_sort_opl.py
def merge_sort(lijst):
    lengte = len(lijst)
    if lengte < 2:
        return lijst
    else:
        halve_lengte = lengte // 2
        eerste_helft = merge_sort(lijst[:halve_lengte])
        tweede_helft = merge_sort(lijst[halve_lengte:])
        return samenvoegen(eerste_helft, tweede_helft)
    
# code overgenomen uit 4_samenvoegen_in_place    
def samenvoegen (lijst_1, lijst_2):
    resultaat = []
    index_1 = 0
    index_2 = 0

    # hoofdlus
    while index_1 < len(lijst_1) and index_2 < len(lijst_2):
        if lijst_1[index_1] < lijst_2[index_2]:
            resultaat.append(lijst_1[index_1])
            index_1 += 1
        else:
            resultaat.append(lijst_2[index_2])
            index_2 += 1

    # behandel wat er overblijft van lijst_1
    while index_1 < len(lijst_1):
        resultaat.append(lijst_1[index_1])
        index_1 += 1

    # behandel wat er overblijft van lijst_2
    while index_2 < len(lijst_2):
        resultaat.append(lijst_2[index_2])
        index_2 += 1

    return resultaat

# code overgenomen uit 3_isort_opl (hoofdstuk 9)

def sorteer(lijst):
    for lengte in range(1,len(lijst)):   # lengte van het groene deel
        getal = lijst[lengte]            # gele getal
        # bijna letterlijke kopie van invoegen(…)
        index = lengte - 1
        while index >= 0 and lijst[index] > getal:
            lijst[index+1] = lijst[index]
            index -= 1
        lijst[index+1] = getal

# tijdsmeting waarbij we de grootte van de lijst telkens verdubbelen
from random import randint;
from time import time;

print ("samenvoegen  invoegen")
for n in range(10000,26000,1000):
    # een willekeurige lijst van n getallen in het bereik [0,n]
    lijst = []
    for __ in range(n):
        lijst.append(randint(0,n))
    # timing merge sort    
    start_1 = time()
    merge_sort(lijst)     # resultaat wordt niet gebruikt
    verschil_1 = time() - start_1
    # timing sorteren door invoegen
    start_2 = time()
    sorteer(lijst)
    verschil_2 = time() - start_2
    # afdrukken
    print (f"{verschil_1:.4f}       {verschil_2:.4f}")  # 4 cijfers na de komma
        